package com.zipcodewilmington.singlylinkedlist;

import com.sun.xml.internal.bind.AnyTypeAdapter;
import org.w3c.dom.*;

import javax.xml.soap.Node;
import javax.xml.soap.SOAPElement;
import javax.xml.soap.SOAPException;

/**
 * Created by leon on 1/10/18.
 */
public class SinglyLinkedList {

    private static int listCount;
    private Node head;

    public SinglyLinkedList() {
        head = new Node(null);
        listCount = 0;
    }

    public Node getHead() {
        return head;
    }

    public class Node {
        Node next;
        Object data;

        public Node(Object dataValue) {
            next = null;
            data = dataValue;
        }

        public Object getData() {
            return data;
        }

        public Node getNext() {
            return next;
        }

        public void setNext(Node nextValue) {
            next = nextValue;
        }

    }

    public void add(Object data) {

        if(head == null) {
            head = new Node(data);
        }

        Node temp = new Node(data);
        Node current = head;

        if(current != null) {
            while (current.getNext() != null) {
                current = current.getNext();
            }

            current.setNext(temp);
        }
        listCount++;

    }

    public static int size() {
        return listCount;
    }

    public Object get(int index) {
        if (index < 0)
            return null;
        Node current = null;
        if (head != null) {
            current = head.getNext();
            for (int i = 0; i < index; i++) {
                if (current.getNext() == null)
                    return null;

                current = current.getNext();
            }
            return current.getData();
        }
        return current;

    }

    public void remove(int index) {

            Node current = head;
            if (head != null) {
                for (int i = 0; i < index; i++) {
                    if (current.getNext() != null)
                    current = current.getNext();
                }
                current.setNext(current.getNext().getNext());

                listCount--;

            }
        }

    public boolean contains(Object data) {
        Node current = head;
        if (head == null) {
            return false;
        }

        for (int i = 0; i < listCount; i++) {
            if(current.getData() == data) {
                return true;
            } else if (current.getNext() != null)
                current = current.getNext();
        }

        return false;

    }

    public int find(Object data) {
        int index = 0;
        Node current = head;
        for(int i = 0; i < listCount; i++)
            if(current.getData() == data) {
                return index;
            } else {
                current = current.getNext();
                index++;
            }

        return -1;
    }


    //public void sort(Object data) {
      //  if (data.equals(String));
    //}



}
