package com.zipcodewilmington.singlylinkedlist;

import org.junit.Assert;
import org.junit.Test;

/**
 * Created by leon on 1/10/18.
 */
public class SinglyLinkedListTest {

    @Test
    public void testZeroNodes() {
        //Given
        SinglyLinkedList myList = new SinglyLinkedList();
        Object expected = null;

        //When
        SinglyLinkedList.Node test = myList.getHead();
        Object actual = test.getData();

        //Then
        Assert.assertEquals(expected, actual);
    }

    @Test
    public void testOneNodeInList() {
        //Given
        SinglyLinkedList myList = new SinglyLinkedList();
        Integer myObject = 15;
        Object expected = myObject;

        //When
        myList.add(myObject);
        Object actual = myList.get(0);

        //Then
        Assert.assertEquals(expected, actual);
    }

    @Test
    public void testFind() {
        //Given
        SinglyLinkedList myList = new SinglyLinkedList();
        Integer myObject = 15;
        Integer myObject2 = 20;
        Integer myObject3 = 20;
        int expected = 2;

        //When
        myList.add(myObject);
        myList.add(myObject2);
        myList.add(myObject3);
        Object actual = myList.find(myObject3);

        //Then
        Assert.assertEquals(expected, actual);
    }

    @Test
    public void testFindNotThere() {
        //Given
        SinglyLinkedList myList = new SinglyLinkedList();
        Integer myObject = 15;
        Integer myObject2 = 20;
        Integer myObject3 = 20;
        int expected = -1;

        //When
        myList.add(myObject);
        myList.add(myObject3);
        Object actual = myList.find(myObject2);

        //Then
        Assert.assertEquals(expected, actual);
    }

    @Test
    public void testContains() {
        //Given
        SinglyLinkedList myList = new SinglyLinkedList();
        Integer myObject = 15;
        Integer myObject2 = 20;
        Integer myObject3 = 20;
        boolean expected = true;

        //When
        myList.add(myObject);
        myList.add(myObject2);
        myList.add(myObject3);
        boolean actual = myList.contains(myObject2);

        //Then
        Assert.assertEquals(expected, actual);
    }

    @Test
    public void testDoesNotContain() {
        //Given
        SinglyLinkedList myList = new SinglyLinkedList();
        Integer myObject = 15;
        Integer myObject2 = 20;
        Integer myObject3 = 20;
        boolean expected = false;

        //When
        myList.add(myObject);
        myList.add(myObject3);
        boolean actual = myList.contains(myObject2);

        //Then
        Assert.assertEquals(expected, actual);
    }

    @Test
    public void testRemove() {
        //Given
        SinglyLinkedList myList = new SinglyLinkedList();
        Integer myObject = 15;
        Integer myObject2 = 20;
        Integer myObject3 = 25;
        boolean expected = false;

        //When
        myList.add(myObject);
        myList.add(myObject2);
        myList.add(myObject3);
        myList.remove(1);
        boolean actual = myList.contains(myObject);

        //Then
        Assert.assertEquals(expected, actual);
    }

    @Test
    public void testGet() {
        //Given
        SinglyLinkedList myList = new SinglyLinkedList();
        Integer myObject = 15;
        Integer myObject2 = 20;
        Integer myObject3 = 30;
        Object expected = myObject2;

        //When
        myList.add(myObject);
        myList.add(myObject2);
        myList.add(myObject3);
        Object actual = myList.get(2);

        //Then
        Assert.assertEquals(expected, actual);
    }

    @Test
    public void testGetNext() {
        //Given
        SinglyLinkedList myList = new SinglyLinkedList();
        Integer myObject = 15;
        Integer myObject2 = 20;
        Integer myObject3 = 30;

        //When
        myList.add(myObject);
        myList.add(myObject2);
        myList.add(myObject3);
        Object expected = myList.get(1);
        Object actual = myList.getHead().getNext().getData();
        System.out.println(myList.getHead().getData());
        System.out.println(myList.getHead().getNext().getData());
        System.out.println(myList.getHead().getNext().getNext().getData());

        //Then
        Assert.assertEquals(expected, actual);
    }


}
